<?php
 
 
 

namespace PhpWA\Protocol\Proto\Message;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\GPBUtil;
use Google\Protobuf\RepeatedField;




class VideoMessage extends \Google\Protobuf\Internal\Message
{
    


    protected $url = null;
    


    protected $mimetype = null;
    


    protected $fileSha256 = null;
    


    protected $fileLength = null;
    


    protected $seconds = null;
    


    protected $mediaKey = null;
    


    protected $caption = null;
    


    protected $gifPlayback = null;
    


    protected $height = null;
    


    protected $width = null;
    


    protected $fileEncSha256 = null;
    


    private $interactiveAnnotations;
    


    protected $directPath = null;
    


    protected $mediaKeyTimestamp = null;
    


    protected $jpegThumbnail = null;
    


    protected $contextInfo = null;
    


    protected $streamingSidecar = null;
    


    protected $gifAttribution = null;
    


    protected $viewOnce = null;
    


    protected $thumbnailDirectPath = null;
    


    protected $thumbnailSha256 = null;
    


    protected $thumbnailEncSha256 = null;
    


    protected $staticUrl = null;
    


    private $annotations;
    


    protected $accessibilityLabel = null;
    


    private $processedVideos;
    


    protected $externalShareFullVideoDurationInSeconds = null;
    


    protected $motionPhotoPresentationOffsetMs = null;
    


    protected $metadataUrl = null;
    


    protected $videoSourceType = null;
    


    protected $mediaKeyDomain = null;

    






































    public function __construct($data = NULL) {
        \PhpWA\Protocol\Proto\Metadata\WAProto::initOnce();
        parent::__construct($data);
    }

    



    public function getUrl()
    {
        return isset($this->url) ? $this->url : '';
    }

    public function hasUrl()
    {
        return isset($this->url);
    }

    public function clearUrl()
    {
        unset($this->url);
    }

    




    public function setUrl($var)
    {
        GPBUtil::checkString($var, True);
        $this->url = $var;

        return $this;
    }

    



    public function getMimetype()
    {
        return isset($this->mimetype) ? $this->mimetype : '';
    }

    public function hasMimetype()
    {
        return isset($this->mimetype);
    }

    public function clearMimetype()
    {
        unset($this->mimetype);
    }

    




    public function setMimetype($var)
    {
        GPBUtil::checkString($var, True);
        $this->mimetype = $var;

        return $this;
    }

    



    public function getFileSha256()
    {
        return isset($this->fileSha256) ? $this->fileSha256 : '';
    }

    public function hasFileSha256()
    {
        return isset($this->fileSha256);
    }

    public function clearFileSha256()
    {
        unset($this->fileSha256);
    }

    




    public function setFileSha256($var)
    {
        GPBUtil::checkString($var, False);
        $this->fileSha256 = $var;

        return $this;
    }

    



    public function getFileLength()
    {
        return isset($this->fileLength) ? $this->fileLength : 0;
    }

    public function hasFileLength()
    {
        return isset($this->fileLength);
    }

    public function clearFileLength()
    {
        unset($this->fileLength);
    }

    




    public function setFileLength($var)
    {
        GPBUtil::checkUint64($var);
        $this->fileLength = $var;

        return $this;
    }

    



    public function getSeconds()
    {
        return isset($this->seconds) ? $this->seconds : 0;
    }

    public function hasSeconds()
    {
        return isset($this->seconds);
    }

    public function clearSeconds()
    {
        unset($this->seconds);
    }

    




    public function setSeconds($var)
    {
        GPBUtil::checkUint32($var);
        $this->seconds = $var;

        return $this;
    }

    



    public function getMediaKey()
    {
        return isset($this->mediaKey) ? $this->mediaKey : '';
    }

    public function hasMediaKey()
    {
        return isset($this->mediaKey);
    }

    public function clearMediaKey()
    {
        unset($this->mediaKey);
    }

    




    public function setMediaKey($var)
    {
        GPBUtil::checkString($var, False);
        $this->mediaKey = $var;

        return $this;
    }

    



    public function getCaption()
    {
        return isset($this->caption) ? $this->caption : '';
    }

    public function hasCaption()
    {
        return isset($this->caption);
    }

    public function clearCaption()
    {
        unset($this->caption);
    }

    




    public function setCaption($var)
    {
        GPBUtil::checkString($var, True);
        $this->caption = $var;

        return $this;
    }

    



    public function getGifPlayback()
    {
        return isset($this->gifPlayback) ? $this->gifPlayback : false;
    }

    public function hasGifPlayback()
    {
        return isset($this->gifPlayback);
    }

    public function clearGifPlayback()
    {
        unset($this->gifPlayback);
    }

    




    public function setGifPlayback($var)
    {
        GPBUtil::checkBool($var);
        $this->gifPlayback = $var;

        return $this;
    }

    



    public function getHeight()
    {
        return isset($this->height) ? $this->height : 0;
    }

    public function hasHeight()
    {
        return isset($this->height);
    }

    public function clearHeight()
    {
        unset($this->height);
    }

    




    public function setHeight($var)
    {
        GPBUtil::checkUint32($var);
        $this->height = $var;

        return $this;
    }

    



    public function getWidth()
    {
        return isset($this->width) ? $this->width : 0;
    }

    public function hasWidth()
    {
        return isset($this->width);
    }

    public function clearWidth()
    {
        unset($this->width);
    }

    




    public function setWidth($var)
    {
        GPBUtil::checkUint32($var);
        $this->width = $var;

        return $this;
    }

    



    public function getFileEncSha256()
    {
        return isset($this->fileEncSha256) ? $this->fileEncSha256 : '';
    }

    public function hasFileEncSha256()
    {
        return isset($this->fileEncSha256);
    }

    public function clearFileEncSha256()
    {
        unset($this->fileEncSha256);
    }

    




    public function setFileEncSha256($var)
    {
        GPBUtil::checkString($var, False);
        $this->fileEncSha256 = $var;

        return $this;
    }

    



    public function getInteractiveAnnotations()
    {
        return $this->interactiveAnnotations;
    }

    




    public function setInteractiveAnnotations($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \PhpWA\Protocol\Proto\InteractiveAnnotation::class);
        $this->interactiveAnnotations = $arr;

        return $this;
    }

    



    public function getDirectPath()
    {
        return isset($this->directPath) ? $this->directPath : '';
    }

    public function hasDirectPath()
    {
        return isset($this->directPath);
    }

    public function clearDirectPath()
    {
        unset($this->directPath);
    }

    




    public function setDirectPath($var)
    {
        GPBUtil::checkString($var, True);
        $this->directPath = $var;

        return $this;
    }

    



    public function getMediaKeyTimestamp()
    {
        return isset($this->mediaKeyTimestamp) ? $this->mediaKeyTimestamp : 0;
    }

    public function hasMediaKeyTimestamp()
    {
        return isset($this->mediaKeyTimestamp);
    }

    public function clearMediaKeyTimestamp()
    {
        unset($this->mediaKeyTimestamp);
    }

    




    public function setMediaKeyTimestamp($var)
    {
        GPBUtil::checkInt64($var);
        $this->mediaKeyTimestamp = $var;

        return $this;
    }

    



    public function getJpegThumbnail()
    {
        return isset($this->jpegThumbnail) ? $this->jpegThumbnail : '';
    }

    public function hasJpegThumbnail()
    {
        return isset($this->jpegThumbnail);
    }

    public function clearJpegThumbnail()
    {
        unset($this->jpegThumbnail);
    }

    




    public function setJpegThumbnail($var)
    {
        GPBUtil::checkString($var, False);
        $this->jpegThumbnail = $var;

        return $this;
    }

    



    public function getContextInfo()
    {
        return $this->contextInfo;
    }

    public function hasContextInfo()
    {
        return isset($this->contextInfo);
    }

    public function clearContextInfo()
    {
        unset($this->contextInfo);
    }

    




    public function setContextInfo($var)
    {
        GPBUtil::checkMessage($var, \PhpWA\Protocol\Proto\ContextInfo::class);
        $this->contextInfo = $var;

        return $this;
    }

    



    public function getStreamingSidecar()
    {
        return isset($this->streamingSidecar) ? $this->streamingSidecar : '';
    }

    public function hasStreamingSidecar()
    {
        return isset($this->streamingSidecar);
    }

    public function clearStreamingSidecar()
    {
        unset($this->streamingSidecar);
    }

    




    public function setStreamingSidecar($var)
    {
        GPBUtil::checkString($var, False);
        $this->streamingSidecar = $var;

        return $this;
    }

    



    public function getGifAttribution()
    {
        return isset($this->gifAttribution) ? $this->gifAttribution : 0;
    }

    public function hasGifAttribution()
    {
        return isset($this->gifAttribution);
    }

    public function clearGifAttribution()
    {
        unset($this->gifAttribution);
    }

    




    public function setGifAttribution($var)
    {
        GPBUtil::checkEnum($var, \PhpWA\Protocol\Proto\Message\VideoMessage\Attribution::class);
        $this->gifAttribution = $var;

        return $this;
    }

    



    public function getViewOnce()
    {
        return isset($this->viewOnce) ? $this->viewOnce : false;
    }

    public function hasViewOnce()
    {
        return isset($this->viewOnce);
    }

    public function clearViewOnce()
    {
        unset($this->viewOnce);
    }

    




    public function setViewOnce($var)
    {
        GPBUtil::checkBool($var);
        $this->viewOnce = $var;

        return $this;
    }

    



    public function getThumbnailDirectPath()
    {
        return isset($this->thumbnailDirectPath) ? $this->thumbnailDirectPath : '';
    }

    public function hasThumbnailDirectPath()
    {
        return isset($this->thumbnailDirectPath);
    }

    public function clearThumbnailDirectPath()
    {
        unset($this->thumbnailDirectPath);
    }

    




    public function setThumbnailDirectPath($var)
    {
        GPBUtil::checkString($var, True);
        $this->thumbnailDirectPath = $var;

        return $this;
    }

    



    public function getThumbnailSha256()
    {
        return isset($this->thumbnailSha256) ? $this->thumbnailSha256 : '';
    }

    public function hasThumbnailSha256()
    {
        return isset($this->thumbnailSha256);
    }

    public function clearThumbnailSha256()
    {
        unset($this->thumbnailSha256);
    }

    




    public function setThumbnailSha256($var)
    {
        GPBUtil::checkString($var, False);
        $this->thumbnailSha256 = $var;

        return $this;
    }

    



    public function getThumbnailEncSha256()
    {
        return isset($this->thumbnailEncSha256) ? $this->thumbnailEncSha256 : '';
    }

    public function hasThumbnailEncSha256()
    {
        return isset($this->thumbnailEncSha256);
    }

    public function clearThumbnailEncSha256()
    {
        unset($this->thumbnailEncSha256);
    }

    




    public function setThumbnailEncSha256($var)
    {
        GPBUtil::checkString($var, False);
        $this->thumbnailEncSha256 = $var;

        return $this;
    }

    



    public function getStaticUrl()
    {
        return isset($this->staticUrl) ? $this->staticUrl : '';
    }

    public function hasStaticUrl()
    {
        return isset($this->staticUrl);
    }

    public function clearStaticUrl()
    {
        unset($this->staticUrl);
    }

    




    public function setStaticUrl($var)
    {
        GPBUtil::checkString($var, True);
        $this->staticUrl = $var;

        return $this;
    }

    



    public function getAnnotations()
    {
        return $this->annotations;
    }

    




    public function setAnnotations($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \PhpWA\Protocol\Proto\InteractiveAnnotation::class);
        $this->annotations = $arr;

        return $this;
    }

    



    public function getAccessibilityLabel()
    {
        return isset($this->accessibilityLabel) ? $this->accessibilityLabel : '';
    }

    public function hasAccessibilityLabel()
    {
        return isset($this->accessibilityLabel);
    }

    public function clearAccessibilityLabel()
    {
        unset($this->accessibilityLabel);
    }

    




    public function setAccessibilityLabel($var)
    {
        GPBUtil::checkString($var, True);
        $this->accessibilityLabel = $var;

        return $this;
    }

    



    public function getProcessedVideos()
    {
        return $this->processedVideos;
    }

    




    public function setProcessedVideos($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \PhpWA\Protocol\Proto\ProcessedVideo::class);
        $this->processedVideos = $arr;

        return $this;
    }

    



    public function getExternalShareFullVideoDurationInSeconds()
    {
        return isset($this->externalShareFullVideoDurationInSeconds) ? $this->externalShareFullVideoDurationInSeconds : 0;
    }

    public function hasExternalShareFullVideoDurationInSeconds()
    {
        return isset($this->externalShareFullVideoDurationInSeconds);
    }

    public function clearExternalShareFullVideoDurationInSeconds()
    {
        unset($this->externalShareFullVideoDurationInSeconds);
    }

    




    public function setExternalShareFullVideoDurationInSeconds($var)
    {
        GPBUtil::checkUint32($var);
        $this->externalShareFullVideoDurationInSeconds = $var;

        return $this;
    }

    



    public function getMotionPhotoPresentationOffsetMs()
    {
        return isset($this->motionPhotoPresentationOffsetMs) ? $this->motionPhotoPresentationOffsetMs : 0;
    }

    public function hasMotionPhotoPresentationOffsetMs()
    {
        return isset($this->motionPhotoPresentationOffsetMs);
    }

    public function clearMotionPhotoPresentationOffsetMs()
    {
        unset($this->motionPhotoPresentationOffsetMs);
    }

    




    public function setMotionPhotoPresentationOffsetMs($var)
    {
        GPBUtil::checkUint64($var);
        $this->motionPhotoPresentationOffsetMs = $var;

        return $this;
    }

    



    public function getMetadataUrl()
    {
        return isset($this->metadataUrl) ? $this->metadataUrl : '';
    }

    public function hasMetadataUrl()
    {
        return isset($this->metadataUrl);
    }

    public function clearMetadataUrl()
    {
        unset($this->metadataUrl);
    }

    




    public function setMetadataUrl($var)
    {
        GPBUtil::checkString($var, True);
        $this->metadataUrl = $var;

        return $this;
    }

    



    public function getVideoSourceType()
    {
        return isset($this->videoSourceType) ? $this->videoSourceType : 0;
    }

    public function hasVideoSourceType()
    {
        return isset($this->videoSourceType);
    }

    public function clearVideoSourceType()
    {
        unset($this->videoSourceType);
    }

    




    public function setVideoSourceType($var)
    {
        GPBUtil::checkEnum($var, \PhpWA\Protocol\Proto\Message\VideoMessage\VideoSourceType::class);
        $this->videoSourceType = $var;

        return $this;
    }

    



    public function getMediaKeyDomain()
    {
        return isset($this->mediaKeyDomain) ? $this->mediaKeyDomain : 0;
    }

    public function hasMediaKeyDomain()
    {
        return isset($this->mediaKeyDomain);
    }

    public function clearMediaKeyDomain()
    {
        unset($this->mediaKeyDomain);
    }

    




    public function setMediaKeyDomain($var)
    {
        GPBUtil::checkEnum($var, \PhpWA\Protocol\Proto\Message\MediaKeyDomain::class);
        $this->mediaKeyDomain = $var;

        return $this;
    }

}

